﻿Long Arm

Provides tools to make planet-wide building a little easier. Open UI with Control+L (configurable in Settings). Starts up with inspect and bot build range extended, 
but with no Build Helper Modes enabled. 

Does not affect saved games, build range changes are reverted prior to the game saving its data

Use the Build Status window to see how many of each item type are still needed
![Config](https://github.com/mattsemar/dsp-long-arm/blob/master/Examples/BuildStatus.png?raw=true)

### Build Helper Modes

In addition to extending build range, additional modes are provided to make building planet wide blueprints a little less painful. These are optional, but may
be useful in certain situations. All 3 of the active ones will work even when the build range is not overridden.

* FlyToBuild - queues up commands to send the mecha to nearby build previews (until all are built)
* FastBuild - slightly cheaty option where builds are done as quickly as the game allows but inventory items _are_ consumed, however bot travel time is ignored
* FreeBuild - very cheaty option where inventory items are not consumed, builds are done as quickly as the game allows. This mode will disable achievements for your save. This mode is generally
limited by the number of updates per second your computer can do while adding factory machines at a very high speed.
* None - default setting at each game start in order to prevent accidental disabling of achievements in the case where a different game save was loaded after setting FreeBuild mode

### KeyBinds 

Open game settings to rebind or unbind the keys under the Control tab
![Config](https://github.com/mattsemar/dsp-long-arm/blob/master/Examples/keybinds.png?raw=true)


This mod requires BepInEx to function, download and install it
first: [link](https://bepinex.github.io/bepinex_docs/master/articles/user_guide/installation/index.html?tabs=tabid-win)

#### Manually

First install the [CommonAPI](https://dsp.thunderstore.io/package/CommonAPI/CommonAPI/) mod, this mod depends on it.
Next, download the archive file, extract contents and drag `LongArm.dll` into the `BepInEx/plugins` directory. 

#### Mod manager

Click the `Install with Mod Manager` link above. Make sure dependencies are installed, if prompted. This mod will do basically nothing if the keybinds don't get registered, keybinds are 
now supplied from CommonAPI

## Changelog

#### v1.2.1
Resolved FastBuild/FreeBuild mode performance issue on planets with lots of assembling machines.
Adjusted height of tour window

#### v1.2.0
Added support for adding fuel to all generators across all factories (hold CTRL while hitting button)
Switched to CommonAPI for keybind registration

#### v1.1.3
Bugfix - fixed issue with FastBuild mode when returning to planet with unrealized prebuilds by delaying action while player is in "sail" mode.   

#### v1.1.1/2
Rebuild against latest game version

#### v1.1.0
Fixed exception thrown when preview window layout changes
Added factory tour mode to help locate things on planet factory faster

#### v1.0.1
Rebuild to sync with latest version of game

#### v1.0.0
Added Build Status window to show blueprinted items vs. inventory counts
Added "Add Bots" button for filling stations all stations on planet with drones/vessels (configurable)
Tweaked Free & Fast Build modes to run much more quickly 

#### v0.2.0
Added "Add Fuel" action for jumpstarting power network with missing fuel from player inventory
Fixed issue with count of remaining prebuilds in FastBuild mode

#### v0.1.0
Made build helper modes independent from settings to extend build/inspect range

#### v0.0.1
First version

## Contact
Bugs? Contact me on discord: mattersnot#1983 or create an issue in the github repository.
